PPIx::QuoteLike::Token::Interpolation(3)

NAME
PPIx::QuoteLike::Token::Interpolation - Represent an interpolation

SYNOPSIS
This class should not be instantiated by the user. See below for public methods.

INHERITANCE
"PPIx::QuoteLike::Token::Interpolation" is a PPIx::QuoteLike::Token.

"PPIx::QuoteLike::Token::Interpolation" has no descendants.

DESCRIPTION
This Perl class represents an interpolation into a quote-like string.

METHODS
This class supports the following public methods in addition to those of its superclass:

  ppi
 my $ppi = $elem->ppi();

This convenience method returns the PPI::Document representing the content. This document should be considered read only. An exception will be thrown if PPI::Document can not be loaded.

Note that the content of the returned PPI::Document may not be the same as the content of the original "PPIx::Regexp::Token::Interpolation". This can happen because interpolated variable names may be enclosed in curly brackets, but this does not happen in normal code. For example, in "/${foo}bar/", the content of the "PPIx::Regexp::Token::Interpolation" object will be '${foo}', but the content of the "PPI::Document" will be '$foo'.

  variables
 say "Interpolates $_" for $elem->variables();

NOTE that this method is discouraged, and may well be deprecated and removed. I have two problems with it. The first is that it returns variable names rather than PPI::Element objects, leaving you no idea how the variables are used. The second is that it does not properly handle things like "${^CAPTURE[0]}", and it seems infeasible to make it do so. It was originally written for the benefit of Perl::Critic::Policy::Variables::ProhibitUnusedVarsStricter, but has proven inadequate to that policy's needs.

This convenience method returns all interpolated variables. Each is returned only once, and they are returned in no particular order.

SEE ALSO
PPIx::QuoteLike::Token.

SUPPORT
Support is by the author. Please file bug reports at <https://rt.cpan.org/Public/Dist/Display.html?Name=PPIx-QuoteLike>, <https://github.com/trwyant/perl-PPIx-QuoteLike/issues>, or in electronic mail to the author.

AUTHOR
Thomas R. Wyant, III wyant at cpan dot org

COPYRIGHT AND LICENSE
Copyright (C) 2016-2022 by Thomas R. Wyant, III

This program is free software; you can redistribute it and/or modify it under the same terms as Perl 5.10.0. For more details, see the full text of the licenses in the directory LICENSES.

This program is distributed in the hope that it will be useful, but without any warranty; without even the implied warranty of merchantability or fitness for a particular purpose.